% Demo of analog to digital conversion errors
% 6/1/06 
% 2006 Copyright D. E. Adams

clear all;
close all;

% Parameters
Nt=500;
dt=0.0002;
t=(0:dt:(Nt-1)*dt)';
qinterval=.1563;    % Set quantization interval

% Signal definition
y=3*sin(2*pi*500*t);
y1=5*sin(2*pi*60*t);

% Plot results for 60 Hz noise example
figure(1);
subplot(211);
plot(t,y,'k.-');
axis([0 .04 -10 10]);
xlabel('Time [s]');
ylabel('y [V]');
subplot(212);
plot(t,y+y1,'k.-');
axis([0 .04 -10 10]);
xlabel('Time [s]');
ylabel('y [V]');

% Plot results for DC noise example
figure(2);
subplot(211);
plot(t,y,'k.-');
axis([0 .04 -10 10]);
xlabel('Time [s]');
ylabel('y [V]');
subplot(212);
plot(t,y+5,'k.-');
axis([0 .04 -10 10]);
xlabel('Time [s]');
ylabel('y [V]');

% Plot quantized results
y3=y+y1;
u=y3;
qinterval=10/2^4;
sim('quantizeinput');
y3d=yd;
y4=y+5;
u=y4;
sim('quantizeinput');
y4d=yd;
u=y3;
qinterval=20/2^4;
sim('quantizeinput');
y3d2=yd;
u=y4;
sim('quantizeinput');
y4d2=yd;
figure(3);
subplot(211);
plot(t,y3,'k:',t,y3d,'ko-',t,y3d2,'kx-')
axis([0 .005 -1 10]);
xlabel('Time [s]');
ylabel('y [V]');
subplot(212);
plot(t,y4,'k:',t,y4d,'ko-',t,y4d2,'kx-')
axis([0 .005 -1 10]);
xlabel('Time [s]');
ylabel('y [V]');