% Sensor transmission model
% 4/14/06 
% 2006 Copyright D. E. Adams

clear all;
close all;

% Parameters
omegan=1;
zeta1=.01;
zeta2=.1;
zeta3=.7;

% Construct frequency vector in rad/sec
w=(.1:.01:100)';

% Invert the impedance function at each frequency
for ii=1:max(size(w)),
    H1(ii)=(j*2*zeta1*w(ii)/omegan+1)./(-w(ii)^2/omegan^2+j*2*zeta1*w(ii)/omegan+1);
    H2(ii)=(j*2*zeta2*w(ii)/omegan+1)./(-w(ii)^2/omegan^2+j*2*zeta2*w(ii)/omegan+1);
    H3(ii)=(j*2*zeta3*w(ii)/omegan+1)./(-w(ii)^2/omegan^2+j*2*zeta3*w(ii)/omegan+1);
end

figure(1);
subplot(211);
loglog(w,abs(squeeze(H1)),'k-',w,abs(squeeze(H2)),'k--',w,abs(squeeze(H3)),'k:');
xlabel('Frequency [Hz]');
ylabel('Mag. X_s/X_b [m/m]');
xlim([.1 100]);
ylim([1e-3 1e2]);
subplot(212);
semilogx(w,180/pi*angle(squeeze(H1)),'k-',w,180/pi*angle(squeeze(H2)),'k--',w,180/pi*angle(squeeze(H3)),'k:');
xlabel('Frequency [Hz]');
ylabel('Phs. X_s/X_b [deg]');
xlim([.1 100]);
ylim([-180 10]);