function hos=hospec(x,T,pick);
% function hos=hospec(x,T,pick)
%
% Higher order spectra algorithm
% for Bispectrum and Trispectrum.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Compute averaged Fourier spectrum (2000 samples per FFT)
% Get needed parameters (min(BS)=213)
BS=2048;
[Ntpts,n]=size(T);
Navgs=Ntpts/BS;

% Compute average Fourier spectrum
avg_sf=zeros(BS,1);
offset=0;
sz=60;
if pick==4, temp_hos=zeros(sz,sz,sz); end
if pick==3, temp_hos=zeros(sz,sz); end

for m = 1:Navgs,
   tmp_sf=fft(hanning(BS).*x(1+(m-1)*BS:m*BS));
   avg_sf=avg_sf+tmp_sf;
   
if pick==4,
% Compute fourth order spectra (trispectra)
for j = 1:round(sz),
   for i = 1:round(sz),
      for k = 1:round(sz),
          temp_hos(i,j,k)=temp_hos(i,j,k)+conj(tmp_sf(i+offset))*conj(tmp_sf(j+offset))*conj(tmp_sf(k+offset))*tmp_sf(i+offset+j+offset+k+offset);
      end
   end
end

elseif pick==3,
% Compute third order spectra (bispectrum)
for j = 1:round(sz),
   for i = 1:round(sz),
      temp_hos(i,j)=temp_hos(i,j)+conj(tmp_sf(i+offset))*conj(tmp_sf(j+offset))*tmp_sf(i+offset+j+offset);
   end
end
end

end

hos=temp_hos;