% Piezo circuit frequency response function
% 5/19/06 
% 2006 Copyright D. E. Adams

clear all;
close all;

% Parameters
Rd1=1e5;
Rd2=1e4;
Rd3=1e3;
Cs=10e-9;

% Construct frequency vector in rad/sec
w=logspace(-1,10,100);

% Invert the impedance function at each frequency
for ii=1:max(size(w)),
    H1(ii)=1/(j*w(ii)*Rd1*Cs+1);
    H2(ii)=1/(j*w(ii)*Rd2*Cs+1);
    H3(ii)=1/(j*w(ii)*Rd3*Cs+1);
end

figure(1);
subplot(211);
semilogx(w/2/pi,20*log10(abs(squeeze(H1))),'k-',w/2/pi,20*log10(abs(squeeze(H2))),'k--',w/2/pi,20*log10(abs(squeeze(H3))),'k:');
xlabel('Frequency [Hz]');
ylabel('Mag. V_d/V_s [dB]');
axis([1e-2 1e8 -100 0]);
legend('R_d=1e6 ohm','R_d=1e5 ohm','R_d=1e4 ohm',1);
subplot(212);
semilogx(w/2/pi,180/pi*angle(squeeze(H1)),'k-',w/2/pi,180/pi*angle(squeeze(H2)),'k--',w/2/pi,180/pi*angle(squeeze(H3)),'k:');
xlabel('Frequency [Hz]');
ylabel('Phs. V_d/V_s [deg]');
axis([1e-2 1e8 -100 0]);