% Piezo accelerometer frequency response function
% 5/18/06 
% 2006 Copyright D. E. Adams

clear all;
close all;

% Parameters
omegan=1;
zeta1=.01;
zeta2=.1;
zeta3=.7;

% Construct frequency vector in rad/sec
w=(.001:.01:10)';

% Invert the impedance function at each frequency
for ii=1:max(size(w)),
    H1(ii)=1./(-w(ii)^2+j*2*zeta1*w(ii)+omegan^2);
    H2(ii)=1./(-w(ii)^2+j*2*zeta2*w(ii)+omegan^2);
    H3(ii)=1./(-w(ii)^2+j*2*zeta3*w(ii)+omegan^2);
end

figure(1);
loglog(w,abs((H1)),'k-',w,abs((H2)),'k--',w,abs((H3)),'k:');
xlabel('Frequency [rad/s]');
ylabel('Mag. Z/A_b [m/m/s^2]');
legend('\zeta=.01','\zeta=.1','\zeta=.7',2);
xlim([.001 10]);
ylim([1e-3 1e2]);