% Piezo circuit frequency response function
% 5/19/06 
% 2006 Copyright D. E. Adams

clear all;
close all;

% Parameters
Rd1=1e6;
Rd2=1e5;
Rd3=1e4;
Cs=10e-12;

% Construct frequency vector in rad/sec
w=logspace(-1,10,100);

% Invert the impedance function at each frequency
for ii=1:max(size(w)),
    H1(ii)=(j*w(ii)*Rd1*Cs)/(j*w(ii)*Rd1*Cs+1);
    H2(ii)=(j*w(ii)*Rd2*Cs)/(j*w(ii)*Rd2*Cs+1);
    H3(ii)=(j*w(ii)*Rd3*Cs)/(j*w(ii)*Rd3*Cs+1);
end

figure(1);
loglog(w/2/pi,abs((H1)),'k-',w/2/pi,abs((H2)),'k--',w/2/pi,abs((H3)),'k:');
xlabel('Frequency [Hz]');
ylabel('Mag. V_d/V_s');
legend('R_d=1e6 ohm','R_d=1e5 ohm','R_d=1e4 ohm',1);