function [frf1,frf2]=rfrf(x,y,navg,ovlap)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Computes single-input single-output
% average FRF of long random response and input datasets
% 5/23/06 
% 2006 Copyright D. E. Adams
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Get needed parameters
Nt=max(size(x));
BS=round(Nt/(navg*(1-ovlap)+ovlap));

% Compute average power spectra
gii=zeros(BS,1);
goo=gii;
gio=gii;

for ii = 1:navg,
   inp_sf=fft(hanning(BS).*x(1+(ii-1)*floor(BS*(1-ovlap)):(ii-1)*floor(BS*(1-ovlap))+BS));
   out_sf=fft(hanning(BS).*y(1+(ii-1)*floor(BS*(1-ovlap)):(ii-1)*floor(BS*(1-ovlap))+BS));
   gii=conj(inp_sf).*inp_sf+gii;
   goo=conj(out_sf).*out_sf+goo;
   gio=conj(inp_sf).*out_sf+gio;
end

% Compute average FRF using H1 calculation
frf1=gio./gii;
% frf1=goo./gio;  % Uncomment this line to calculate H2 FRF
frf2=(gio.*conj(gio))./((gii).*(goo)); % Compute ordinary coherence