% Two degree of freedom model
% Free response solution
% 3/26/06 
% 2006 Copyright D. E. Adams

clear all;
close all;

% Parameters
m1=1;
m2=1;
k1=10;
k2=20;
k3=10;

% Generate matrices
M=[m1 0;0 m2];
K=[k1+k2 -k2; -k2 k2+k3];
C=.01*M+.01*K;
A=[zeros(2) eye(2);-inv(M)*K -inv(M)*C];
B=[0 0 1 0]';

% Set initial conditions
% Use an initial condition on the velocity to simluate impact
x10=0;
xd10=1;
x20=0;
xd20=0;

% Generate system in MATLAB
sys=ss(A,B,[eye(2) zeros(2)],zeros(2,1));

% Simulate response
[x,t]=initial(sys,[x10 x20 xd10 xd20]');

% Plot results
figure(1);
plot(t,x(:,1),'-k',t,x(:,2),'--k');
xlabel('Time [sec]');
ylabel('x_1 and x_2 [m]');
legend('x_1','x_2');
xlim([0 10]);