% Two degree of freedom model
% Frequency response solution
% 3/26/06 
% 2006 Copyright D. E. Adams

clear all;
close all;

% Parameters
m1=1;
m2=1;
k1=10;
k2=20;
k3=10;

% Generate matrices
M=[m1 0;0 m2];
K=[k1+k2 -k2; -k2 k2+k3];
C=.01*M+.01*K;

% Construct frequency vector in rad/sec
w=(0:.05:20)';

% Invert the impedance matrix at each frequency
for ii=1:max(size(w)),
    H(1:2,1:2,ii)=inv(-w(ii)^2*M+j*w(ii)*C+K);
end

figure(1);
subplot(411);
plot(w/2/pi,abs(squeeze(H(1,1,:))),'k-');
xlabel('Frequency [Hz]');
ylabel('Mag. H_{11} [m/N]');
xlim([0 3]);
ylim([0 1.5]);
subplot(412);
plot(w/2/pi,180/pi*unwrap(angle(squeeze(H(1,1,:)))),'k-');
xlabel('Frequency [Hz]');
ylabel('Phs. H_{11} [deg]');
xlim([0 3]);
ylim([-400 0]);
subplot(413);
plot(w/2/pi,abs(squeeze(H(2,1,:))),'k-');
xlabel('Frequency [Hz]');
ylabel('Mag. H_{21} [m/N]');
xlim([0 3]);
ylim([0 1.5]);
subplot(414);
plot(w/2/pi,180/pi*unwrap(angle(squeeze(H(2,1,:)))),'k-');
xlabel('Frequency [Hz]');
ylabel('Phs. H_{21} [deg]');
xlim([0 3]);
ylim([-400 0]);

% Continue on with variation in K2
disp('Press any button to continue');
pause;

figure(2);
subplot(211);
plot(w/2/pi,abs(squeeze(H(1,1,:))),'k-'); hold on;
xlabel('Frequency [Hz]');
ylabel('Mag. H_{11} [m/N]');
xlim([0 3]);
ylim([0 1.5]);
subplot(212);
plot(w/2/pi,180/pi*unwrap(angle(squeeze(H(1,1,:)))),'k-'); hold on;
xlabel('Frequency [Hz]');
ylabel('Phs. H_{11} [deg]');
xlim([0 3]);
ylim([-400 0]);

% Generate modified matrices
k2=k2-0.25*k2;
K=[k1+k2 -k2; -k2 k2+k3];
C=.01*M+.01*K;

% Construct frequency vector in rad/sec
w=(0:.05:20)';

% Invert the impedance matrix at each frequency
for ii=1:max(size(w)),
    H(1:2,1:2,ii)=inv(-w(ii)^2*M+j*w(ii)*C+K);
end

figure(2);
subplot(211);
plot(w/2/pi,abs(squeeze(H(1,1,:))),'k--');
subplot(212);
plot(w/2/pi,180/pi*unwrap(angle(squeeze(H(1,1,:)))),'k--');

% Continue on with variation in M2
disp('Press any button to continue');
pause;

% Parameters
m1=1;
m2=1;
k1=10;
k2=20;
k3=10;

% Generate matrices
M=[m1 0;0 m2];
K=[k1+k2 -k2; -k2 k2+k3];
C=.01*M+.01*K;

% Construct frequency vector in rad/sec
w=(0:.05:20)';

% Invert the impedance matrix at each frequency
for ii=1:max(size(w)),
    H(1:2,1:2,ii)=inv(-w(ii)^2*M+j*w(ii)*C+K);
end

figure(3);
subplot(211);
plot(w/2/pi,abs(squeeze(H(1,1,:))),'k-'); hold on;
xlabel('Frequency [Hz]');
ylabel('Mag. H_{11} [m/N]');
xlim([0 3]);
ylim([0 1.5]);
subplot(212);
plot(w/2/pi,180/pi*unwrap(angle(squeeze(H(1,1,:)))),'k-'); hold on;
xlabel('Frequency [Hz]');
ylabel('Phs. H_{11} [deg]');
xlim([0 3]);
ylim([-400 0]);

% Generate modified matrices
m2=m2-0.25*m2;
M=[m1 0;0 m2];
K=[k1+k2 -k2; -k2 k2+k3];
C=.01*M+.01*K;

% Construct frequency vector in rad/sec
w=(0:.05:20)';

% Invert the impedance matrix at each frequency
for ii=1:max(size(w)),
    H(1:2,1:2,ii)=inv(-w(ii)^2*M+j*w(ii)*C+K);
end

figure(3);
subplot(211);
plot(w/2/pi,abs(squeeze(H(1,1,:))),'k--');
subplot(212);
plot(w/2/pi,180/pi*unwrap(angle(squeeze(H(1,1,:)))),'k--');