% Two degree of freedom
% higher order spectral analysis
% 5/22/06 
% 2006 Copyright D. E. Adams

clear all;
close all;

% Create time vector and excitation force
Nt=2^17;                                       % Number of time points
Fs=256; dt=1/Fs;                               % Sampling frequency and time step
t=(0:dt:((Nt-1)*dt))';                         % Time vector

% Linear parameters
M1=1;
M2=1;
K1=10;
K2=20;
K3=10;
M=[M1 0;0 M2];
K=[K1+K2 -K2;-K2 K2+K3];
C=.02*M+.02*K;
C2=-C(1,2);
C1=C(1,1)-C2;
C3=C(2,2)-C2;
mu1=0; % Coulomb friction
mu2=0; % Crack

% Reset the state of random number generator
randn('state',sum(100*clock));

% Input
f1=1*sin(20*t)+1*sin(50*t);

% Simulate linear model
sim('two_dof_model_nl');

xb1=x1;
xb2=x2;

mu2=100; % Crack

% Reset the state of random number generator
randn('state',sum(100*clock));

% Input
f1=1*sin(20*t)+1*sin(50*t);

% Simulate linear model
sim('two_dof_model_nl');

xd1=x1;
xd2=x2;

% Compute bispectra
BS=2048;
bsxb1=hospec(xb1(1:2^16),t(1:2^16),3);
bsxd1=hospec(xd1(1:2^16),t(1:2^16),3);
bsxb2=hospec(xb2(1:2^16),t(1:2^16),3);
bsxd2=hospec(xd2(1:2^16),t(1:2^16),3);
f=(0:1/t(BS):(BS-1)/t(BS))';

% Plot results
figure(1);
stf=1;
enf=60;
subplot(121);
surf(f(stf:enf),f(stf:enf),angle((bsxb2(stf:enf,stf:enf))));
xlim([0 7]);
ylim([0 7]);
xlabel('Freq. [Hz]');
ylabel('Freq. [Hz]');
view(0,90);
subplot(122);
surf(f(stf:enf),f(stf:enf),angle((bsxd2(stf:enf,stf:enf))));
xlabel('Freq. [Hz]');
ylabel('Freq. [Hz]');
xlim([0 7]);
ylim([0 7]);
view(0,90);