function a = wavedn(f0,N)
% Daubechies Wavelet
% Copyright D. E. Newland 1992. All rights reserved
% Ver2: Shankar Sundararaman, May 17, 2005.
% Ver3: Shankar Sundararaman, Mar 22, 2006.
% Automatically truncates the data to length 2^n
if size(f0,2)>1, f0=f0.'; end;
n=floor(log2(length(f0)));% SS, TJJ, Mar 17, 2006.
f=f0(1:2^n);% SS, LM: Mar 22, 2006.
M=length(f);
c=dcoeffs(N);
clr=c(end:-1:1);% SS, LM: Mar 22, 2006.
clr(1:2:N-1)=-clr(1:2:N-1);% SS, LM: May 17, 2005.
a=f;
for kk=n:-1:1,% SS, LM: Mar 22, 2006.
    m=2^(kk-1);
    [km,kN]=meshgrid(1:1:m,1:1:N);
    k=2*km-2+kN;
    k(k>2*m)=rem(k(k>2*m),2*m);% SS, Mar 21, 2006.
    k(k==0)=2*m;% SS, Mar 21, 2006.
    z=a(k);
    a(1:m)=c.'*z/2;
    a(m+1:2*m)=clr.'*z/2;
end;