% Wavelet analysis
% 5/25/06 
% 2006 Copyright D. E. Adams

clear all;
close all;

% Create time vector and frequency vector
Nt=2^14;                                       % Number of time points
Fs=256; dt=1/Fs;                               % Sampling frequency and time step
t=(0:dt:((Nt-1)*dt))';                         % Time vector

% Create linear chirp from 0 to 2.6 Hz
impt=100;
y=sin(2*pi*(0+0.02*t).*t)+[zeros(Nt/2-impt,1); ones(impt/2,1); -ones(impt/2,1); zeros(Nt/2,1)];
freq=[-1 0;0 1;1 2;2 3;3 4;4 5;5 6;6 7;7 8;8 9;9 10;10 11;11 12;12 13;13 14];
bands=2.^freq/2^14*Fs;

% Compute harmonic wavelet map
Mh=hmapdn(y);
th=linspace(0,t(Nt),4096)';

% Compute Dabauchies wavelet map
Md=mapdn(y);
td=linspace(0,t(Nt),8192)';

figure(1);
subplot(121);
plot(t,y,'k-');
xlabel('Time [sec]');
ylabel('y(t)');
xlim([0 62]);
subplot(222);
surf(th,-1:13,(abs(Mh)));
xlabel('Time [sec]')
ylabel('Level, a');
zlabel('M_{a,b}');
shading('interp');
view(0,90);
xlim([0 62]);
ylim([-1 13]);
subplot(224);
surf(td,-1:13,(abs(Md)));
xlabel('Time [sec]')
ylabel('Level, a');
zlabel('M_{a,b}');
shading('interp');
view(0,90);
xlim([0 62]);
ylim([-1 13]);
colormap('prism');